# Guidance for Windows Software Deployment Teams

The ThousandEyes Endpoint Agent for Windows is provided as an MSI package. The Windows installer package (MSI) installs all the components necessary for the Endpoint Agent to function. Further instructions for this can be found [here](https://docs.thousandeyes.com/product-documentation/global-vantage-points/endpoint-agents/installing/download-the-installer)

Your organization has likely tested using browser extensions and Extended Network Tests. Please use the following MSIEXEC switches to customize the installation for your environmental needs. If no switches are provided, the installer will install the base installation that includes support for Extended Network Tests and will not install browser extensions.

## Guidance On Browser Extensions

If your organization is managing browser extensions centrally, it is recommended that you do not install the browser extensions during the MSI deployment. ThousandEyes recommends deploying the browser extension(s) using your extension management processes.

## Command-Line Options for Msiexec / Msiexec Switches.

The following table documents the Msiexec switches:

| Switch                      | Description                         | Action                                                                                                                                                                                                                |
| --------------------------- | ----------------------------------- | --------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------- |
| ExtendedNetworkTestsSupport | Extended Network Tests Support      | Install Windows driver and enable support for Extended Network tests.                                                                                                                                                 |
| EdgeExtension               | Microsoft Edge Browser Extension    | Enable support for collecting network metrics for approved pages in Microsoft Edge.                                                                                                                                   |
| ChromeExtension             | Google Chrome Browser Extension     | Enable support for collecting network metrics for approved pages in Google Chrome.                                                                                                                                    |
| IeExtension                 | Internet Explorer Bowrser Extension | Enable support for collecting network metrics for approved pages in Internet Explore.                                                                                                                                 |
| Agent                       | Endpoint Client Agent               | Optional Switch for base agent installation. This does not include support for the Extended Network Tests.                                                                                                            |
| TcpNetworkTestsSupport      | TCP Network Tests Support           | Install Windows driver and enable support for TCP tests. This switch will be deprecated. More information can be found [here.](https://docs.thousandeyes.com/whats-new/changelog#tcp-tests-renamed-and-on-by-default) |

{% hint style="info" %}
If no Switches are Passed, Extened Network Tests are supported and no Browser Extensions are installed.
{% endhint %}

To install the extensions via the command-line, add the relevant flags shown in the examples below:

* Install with no extensions (default): `msiexec.exe /i <path_to_msi> /quiet /norestart`
* Install with all extensions: `msiexec.exe /i <path_to_msi> /quiet /norestart ADDLOCAL="ExtendedNetworkTestsSupport,IeExtension,ChromeExtension,EdgeExtension"`
* Install with only Internet Explorer extension: `msiexec.exe /i <path_to_msi> /quiet /norestart ADDLOCAL="ExtendedNetworkTestsSupport,IeExtension"`
* Install with all extensions except Internet Explorer: `msiexec.exe /i <path_to_msi> /quiet /norestart ADDLOCAL="ExtendedNetworkTestsSupport,ChromeExtension,EdgeExtension"`

{% hint style="info" %}
The commands listed above require you to subsequently register the agent using the connection string, using this command: `te-agent --register <connection_string>`

The above command needs to be run on the administrator console and the `te-agent` is located at `C:\Program Files (x86)\ThousandEyes\Endpoint Agent`

Alternatively, you can pass the connection string as a parameter and skip the step of registering the agent. The following command installs an agent with no extensions (default):

`msiexec.exe /i <path_to_msi> /quiet /norestart ACCOUNT_CONFIG="<connection_string>"`
{% endhint %}

To view more options, including how to modify existing installs, please view the [Endpoint Agent Installation Reference documentation](https://docs.thousandeyes.com/product-documentation/global-vantage-points/endpoint-agents/installing/endpoint-agent-installation-reference).

## Agent Reinstallation

{% hint style="info" %}
To re-install the agent on the same machine, refer to the instructions \[here]\(<https://docs.thousandeyes.com/product-documentation/global-vantage-points/endpoint-agents/installing/re-install-the-endpoint-agent>).
{% endhint %}

The following table documents the switches for agent reinstallation:

| Switch                           | Description                                      | Action                                                                                                                      |
| -------------------------------- | ------------------------------------------------ | --------------------------------------------------------------------------------------------------------------------------- |
| ENDPOINT\_REINSTALLATION\_METHOD | Defines the mode for the reinstallation process. | The MERGE\_BY\_HOSTNAME answer will prevent duplicate hostnames and tie hostname records together.                          |
| ENDPOINT\_REINSTALLATION\_KEY    | Key to authorize the reinstallation process.     | This key is generated by the account group and ensures only authorized installers are executing the reinstallation process. |

Base reinstallation with no extensions: `msiexec.exe /i <path_to_msi> /quiet /norestart ACCOUNT_CONFIG="<connection_string>" ENDPOINT_REINSTALLATION_METHOD=MERGE_BY_HOSTNAME ENDPOINT_REINSTALLATION_KEY="<reinstallation_key>"`

Base Install with all browser extensions: `msiexec.exe /i <path_to_msi> /quiet /norestart ACCOUNT_CONFIG="<connection_string>" ENDPOINT_REINSTALLATION_METHOD=MERGE_BY_HOSTNAME ENDPOINT_REINSTALLATION_KEY="<reinstallation_key>" ADDLOCAL="ExtendedNetworkTestsSupport,IeExtension,ChromeExtension,EdgeExtension"`

For example, `msiexec.exe /i "C:\Download\Endpoint Agent for Endpoint Agent-x64-1.123.0.msi" /quiet /norestart ACCOUNT_CONFIG="<connection_string>" ENDPOINT_REINSTALLATION_METHOD=MERGE_BY_HOSTNAME ENDPOINT_REINSTALLATION_KEY="1b61d55b-a0fe-4f52-ae18-1d49a8eb0c02" ADDLOCAL="ExtendedNetworkTestsSupport,IeExtension,ChromeExtension,EdgeExtension"`

### Software Updates

The ThousandEyes Endpoint Agent automatically updates. The update schedule is controlled in your ThousandEyes portal. To control this setting, refer [here](https://docs.thousandeyes.com/product-documentation/global-vantage-points/endpoint-agents#endpoint-agent-updates).


---

# Agent Instructions: Querying This Documentation

If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://docs.thousandeyes.com/product-documentation/global-vantage-points/endpoint-agents/installing/guidance-for-windows-software-deployment-team.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
